/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.io.Serializable;
import java.util.Comparator;

import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.system.dao.CmOutPutDao;
import jp.mosp.system.dto.CmOutPutDto;
import jp.mosp.system.vo.OutPutMasterListVo;

public class OutPutMasterListAction extends MosPAction {

	// コマンド
	private static final String CMD_CODE_LIST_SHOW      = "S1220";	// 表示
	private static final String CMD_CODE_LIST_SELECT    = "S1221";	// 検索
	private static final String CMD_CODE_LIST_RE_SEARCH = "S1222";	// 再検索
	private static final String CMD_CODE_LIST_SORT      = "S1223";	// ソート

	/**
	 * コンストラクタ
	 */
	public OutPutMasterListAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// 計算管理権限確認
		confirmCalculateAuth();
		// VOの取得
		OutPutMasterListVo vo;
		Object obj = session.getAttribute(MospConst.ATT_FORMER_VO);
		if (obj instanceof OutPutMasterListVo) {
			vo = (OutPutMasterListVo)obj;
			vo.clearMessage();
			vo.clearErrField();
		} else {
			vo = new OutPutMasterListVo();
		}		
		vo.clearMessage();
		vo.clearErrField();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		session.setAttribute(MospConst.ATT_FORMER_VO, vo);
		// 範囲プルダウンリスト作成
		vo.aryPltScope = getOutputScopeArray();
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_LIST_SHOW)) {
			// 表示処理
			// 検索履歴を初期値にセット
			vo.setSearchmode(OutPutMasterListVo.SEARCH_OFF);
		} else if (cmd.equals(CMD_CODE_LIST_SELECT)) {
			// 検索処理
			vo.setParams(request);
			searchCodeList(vo);
			vo.setIsAscending(true);
			vo.initListInfo();
			// 検索履歴をありにセット
			vo.setSearchmode(OutPutMasterListVo.SEARCH_ON);
		} else if (cmd.equals(CMD_CODE_LIST_RE_SEARCH)) {
			// 再検索
			if(vo.getSearchmode() == OutPutMasterListVo.SEARCH_ON){
				session.removeAttribute(MospConst.ATT_DTO);
				searchCodeList(vo);
				vo.setPageButton();
				sortList(vo);
			}
		} else if (cmd.equals(CMD_CODE_LIST_SORT)) {
			// ソート
			sortList(key1, vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * コードリスト検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	private void searchCodeList(OutPutMasterListVo vo) throws Exception {
		// 検索
		CmOutPutDao dao = new CmOutPutDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setFields(dao.findForSearch(vo.getTxtCode(),vo.getTxtName(),vo.getPltScope()));
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryOutPutMaster().length == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}

	/**
	 * ソート
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(String key, OutPutMasterListVo vo) throws MospException {
		vo.sortList(key, getComparator(key, vo));
		vo.setFields(vo.getList());
	}

	/**
	 * ソート(VO内のキー情報でソート)
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(OutPutMasterListVo vo) throws MospException {
		vo.sortList(getComparator(vo.getFormerKey(), vo));
		vo.setFields(vo.getList());
	}

	/**
	 * 比較クラス取得
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private Comparator getComparator(String key, OutPutMasterListVo vo) throws MospException {
		Comparator comp = null;
		if (key.equals(vo.KEY_CODE)) {
			comp = new CompCode();
		} else if (key.equals(vo.KEY_NAME)) {
			comp = new CompName();
		} else if (key.equals(vo.KEY_SCOPE)) {
			comp = new CompScope();
		} else if (key.equals(vo.KEY_INDEX)) {
			comp = new CompIndex();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}

	/**
	 * コマンドNo.による比較クラス
	 */
	protected static class CompCode implements Comparator, Serializable {
		private static final long serialVersionUID = 2092325382735270514L;
		public int compare(Object obj1, Object obj2) {
			CmOutPutDto dto1 = (CmOutPutDto)obj1;
			CmOutPutDto dto2 = (CmOutPutDto)obj2;
			return dto1.getCode().compareTo(dto2.getCode());
		}
	}

	/**
	 * ボタン名称による比較クラス
	 */
	protected static class CompName implements Comparator, Serializable {
		private static final long serialVersionUID = 1566211673543838675L;
		public int compare(Object obj1, Object obj2) {
			CmOutPutDto dto1 = (CmOutPutDto)obj1;
			CmOutPutDto dto2 = (CmOutPutDto)obj2;
			return dto1.getName().compareTo(dto2.getName());
		}
	}

	/**
	 * 印刷範囲による比較クラス
	 */
	protected static class CompScope implements Comparator, Serializable {
		private static final long serialVersionUID = -6641642982714466781L;
		public int compare(Object obj1, Object obj2) {
			CmOutPutDto dto1 = (CmOutPutDto)obj1;
			CmOutPutDto dto2 = (CmOutPutDto)obj2;
			return dto1.getScope().compareTo(dto2.getScope());
		}
	}

	/**
	 * 表示順による比較クラス
	 */
	protected static class CompIndex implements Comparator, Serializable {
		private static final long serialVersionUID = 2867298555927778701L;
		public int compare(Object obj1, Object obj2) {
			CmOutPutDto dto1 = (CmOutPutDto)obj1;
			CmOutPutDto dto2 = (CmOutPutDto)obj2;
			return String.valueOf(dto1.getViewIndex()).compareTo(String.valueOf(dto2.getViewIndex()));
		}
	}

}
